(function ($, ej, undefined) {
    var colKeysCalcValues = [], rowKeysCalcValues = [], tableKeysCalcValues = [], gridMatrix = null, columnHeaders = null, valueArea = null, rowTotCalc = [], colTotCalc = [],
    tranposeEngine = [], tRowCnt = 0, tColCnt = 0, cellType = "", sortedElements, filteredMembers, fieldMembers = {}, summaryTypes = [];
    ej.PivotAnalysis = {
        pivotEnginePopulate: function (dataSource) {
            var colAxis = dataSource.columns, rowAxis = dataSource.rows, filters = dataSource.filters, calcValues = dataSource.values, colLen, jsonObj = [], pivotFieldList = [], rowLen;
            summaryTypes = [];
            for (var i = 0; i < calcValues.length; i++) summaryTypes.push(calcValues[i].summaryType != null && calcValues[i].summaryType != undefined ? calcValues[i].summaryType : ej.PivotAnalysis.SummaryType.Sum);
            if (dataSource.data != null) {
                for (var cnt = 0; cnt < dataSource.data.length; cnt++) {
                    list = dataSource.data[cnt];
                    var table = { keys: [], uniqueName: "", value: null }, row = { keys: [], uniqueName: "", value: null }, col = { keys: [], uniqueName: "", value: null }, values = { keys: [], uniqueName: "", value: null };
                    var isExcluded = false;

                    for (var i = 0; i < filters.length; i++) {
                        var val = this._getReflectedValue(list, filters[i].fieldName);
                        if (fieldMembers[filters[i].fieldName] == undefined || fieldMembers[filters[i].fieldName] == null)
                            fieldMembers[filters[i].fieldName] = [val];
                        else if ($.inArray(val, fieldMembers[filters[i].fieldName]) == -1)
                            fieldMembers[filters[i].fieldName].push(val);
                        if (filters[i].filterItems != null && filters[i].filterItems != undefined) {
                            if (((filters[i].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || filters[i].filterItems.filterType == null) && $.inArray(val.toString(), filters[i].filterItems.values) >= 0) || (filters[i].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val.toString(), rowAxis[rC].filterItems.values) < 0)) {
                                isExcluded = true;
                                break;
                            }
                        }
                    }

                    for (var nC = 0; nC < calcValues.length; nC++) {
                        var val = "";
                        if (calcValues[nC] != undefined && calcValues[nC] != null) {
                            val = this._getReflectedValue(list, calcValues[nC].fieldName);
                            if (fieldMembers[calcValues[nC].fieldName] == undefined || fieldMembers[calcValues[nC].fieldName] == null)
                                fieldMembers[calcValues[nC].fieldName] = [val];
                            else if ($.inArray(val, fieldMembers[calcValues[nC].fieldName]) == -1)
                                fieldMembers[calcValues[nC].fieldName].push(val);
                        }
                        if ($.isNumeric(val))
                            values.keys.push(val);
                        else
                            values.keys.push(1);
                    }

                    for (var rC = 0; rC < rowAxis.length; rC++) {
                        var val = "";
                        if (rowAxis[rC] != undefined && rowAxis[rC] != null) {
                            val = this._getReflectedValue(list, rowAxis[rC].fieldName);
                            if (fieldMembers[rowAxis[rC].fieldName] == undefined || fieldMembers[rowAxis[rC].fieldName] == null)
                                fieldMembers[rowAxis[rC].fieldName] = [val];
                            else if ($.inArray(val, fieldMembers[rowAxis[rC].fieldName]) == -1)
                                fieldMembers[rowAxis[rC].fieldName].push(val);
                            if (rowAxis[rC].filterItems != null && rowAxis[rC].filterItems != undefined) {
                                if (((rowAxis[rC].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || rowAxis[rC].filterItems.filterType == null) && $.inArray(val.toString(), rowAxis[rC].filterItems.values) >= 0) || (rowAxis[rC].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val.toString(), rowAxis[rC].filterItems.values) < 0)) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                        }
                        row.keys.push(val)
                        row.uniqueName += (row.uniqueName == "" ? val : ("." + val));
                        table.keys.push(val);
                        table.uniqueName += (table.uniqueName == "" ? val : ("." + val));
                    }

                    for (var cC = 0; cC < colAxis.length; cC++) {
                        var val = "";
                        if (colAxis[cC] != undefined && colAxis[cC] != null) {
                            val = this._getReflectedValue(list, colAxis[cC].fieldName);
                            if (fieldMembers[colAxis[cC].fieldName] == undefined || fieldMembers[colAxis[cC].fieldName] == null)
                                fieldMembers[colAxis[cC].fieldName] = [val];
                            else if ($.inArray(val, fieldMembers[colAxis[cC].fieldName]) == -1)
                                fieldMembers[colAxis[cC].fieldName].push(val);
                            if (colAxis[cC].filterItems != null && colAxis[cC].filterItems != undefined) {
                                if (((colAxis[cC].filterItems.filterType == ej.PivotAnalysis.FilterType.Exclude || colAxis[cC].filterItems.filterType == null) && $.inArray(val.toString(), colAxis[cC].filterItems.values) >= 0) || (colAxis[cC].filterItems.filterType == ej.PivotAnalysis.FilterType.Include && $.inArray(val.toString(), colAxis[cC].filterItems.values) < 0)) {
                                    isExcluded = true;
                                    break;
                                }
                            }
                        }
                        col.keys.push(val);
                        col.uniqueName += (col.uniqueName == "" ? val : ("." + val));
                        table.keys.push(val);
                        table.uniqueName += (table.uniqueName == "" ? val : ("." + val));
                    }

                    if (!isExcluded) {
                        this._isMemberExist("row", row, $.extend(true, {}, values));
                        this._isMemberExist("column", col, $.extend(true, {}, values));
                        this._isMemberExist("calc", table, $.extend(true, {}, values));
                    }

                    jQuery.each(list, function (fieldName, value) {
                        if ((jQuery.inArray(fieldName, pivotFieldList)) == -1)
                            pivotFieldList.push(fieldName);
                    });

                    var treeviewData = [];
                    for (var t = 0; t < pivotFieldList.length; t++) {
                        var checkedState = $.grep(dataSource.rows, function (item) { return item.fieldName == pivotFieldList[t]; }).length > 0 || $.grep(dataSource.columns, function (item) { return item.fieldName == pivotFieldList[t]; }).length > 0 || $.grep(dataSource.values, function (item) { return item.fieldName == pivotFieldList[t]; }).length > 0 || $.grep(dataSource.filters, function (item) { return item.fieldName == pivotFieldList[t]; }).length > 0;
                        treeviewData.push({ id: pivotFieldList[t], name: pivotFieldList[t], isSelected: checkedState, spriteCssClass: "" });
                    }
                }
            }

            if (rowAxis.length > 0)
                rowKeysCalcValues = this._sortHeaders(rowKeysCalcValues, rowAxis, 0);
            if (colAxis.length > 0)
                colKeysCalcValues = this._sortHeaders(colKeysCalcValues, colAxis, 0);

            var axisLen = (calcValues.length > 1 ? 1 : 2);
            if (colAxis.length > 0)
                this._insertTotalHeader(axisLen, colAxis, colKeysCalcValues);
            if (rowAxis.length > 0)
                this._insertTotalHeader(2, rowAxis, rowKeysCalcValues);
            else
                rowKeysCalcValues[0].keys[0] = "Grand Total";

            tRowCnt = 0, tColCnt = 0;
            if (calcValues.length > 0)
                this._calculateValues(dataSource);
            colTotCalc = [], rowTotCalc = [], colKeysCalcValues = []; rowKeysCalcValues = []; tableKeysCalcValues = [];
            for (var rCnt = 0; rCnt < (tRowCnt - 1) ; rCnt++) {
                for (var cCnt = 0; cCnt < (tColCnt - 1) ; cCnt++) {
                    if (tranposeEngine[cCnt] == undefined)
                        tranposeEngine[cCnt] = [];
                    if (gridMatrix[rCnt] != undefined && gridMatrix[rCnt][cCnt] != undefined)
                        tranposeEngine[cCnt][rCnt] = {
                            Index: cCnt + ',' + rCnt, CSS: gridMatrix[rCnt][cCnt].CSS, Value: ((typeof (gridMatrix[rCnt][cCnt]) === 'string' || typeof (gridMatrix[rCnt][cCnt]) === 'number' || typeof (gridMatrix[rCnt][cCnt]) === 'object') ? gridMatrix[rCnt][cCnt].Value == 0 ? "" : gridMatrix[rCnt][cCnt].Value == undefined ? "" : gridMatrix[rCnt][cCnt].Value : ""), State: gridMatrix[rCnt][cCnt].State,
                            RowSpan: (gridMatrix[rCnt][cCnt].RowSpan != undefined ? gridMatrix[rCnt][cCnt].RowSpan : 1),
                            ColSpan: (gridMatrix[rCnt][cCnt].ColSpan != undefined ? gridMatrix[rCnt][cCnt].ColSpan : 1), Info: "", Span: "None", Expander: gridMatrix[rCnt][cCnt].Expander
                        };
                    else if (gridMatrix[rCnt] != undefined)
                        tranposeEngine[cCnt][rCnt] = {
                            Index: cCnt + ',' + rCnt, CSS: "none", Value: "", State: 0,
                            RowSpan: 1,
                            ColSpan: 1, Info: "", Span: "None", Expander: 0
                        };
                }
            }

            gridMatrix = [];
            for (var rCnt = 0; rCnt < (tColCnt - 1) ; rCnt++) {
                rowAxis.length = rowAxis.length == 0 ? 1 : rowAxis.length;
                if (rCnt < rowAxis.length)
                    for (var tcnt = 0; tcnt < colAxis.length + 1 ; tcnt++)
                        jsonObj.push({
                            Index: rCnt + ',' + tcnt, CSS: "none", Value: "", State: 0,
                            ColSpan: ((rCnt == 0 && tcnt == 0) ? rowAxis.length : 1),
                            RowSpan: ((rCnt == 0 && tcnt == 0) ? colAxis.length + 1 : 1), Info: "", Span: "None", Expander: 0
                        });
                for (var cCnt = 0; cCnt < (tRowCnt - 1) ; cCnt++) {
                    if (tranposeEngine[rCnt] != undefined && tranposeEngine[rCnt][cCnt] != undefined && !(cCnt < colAxis.length + 1 && rCnt < rowAxis.length))
                        jsonObj.push(tranposeEngine[rCnt][cCnt]);
                }
            }

            tranposeEngine = [];
            if (dataSource.rows[0] == undefined)
                dataSource.rows.length = 0;
            return ({ json: jsonObj, report: dataSource, treeviewData: treeviewData });
        },

        getMembers: function (field) {
            return fieldMembers[field];
        },

        _sortHeaders: function (memberArray, axisElements, level) {
            var subArray = [], resultantArray = [], membersCount = 0;
            var sortedArray = axisElements[level].sortOrder != null && axisElements[level].sortOrder == ej.PivotAnalysis.SortOrder.Descending ? $.Enumerable.From(memberArray).OrderByDescending("$.keys[" + level + "]").ToArray() : $.Enumerable.From(memberArray).OrderBy("$.keys[" + level + "]").ToArray();
            while (membersCount < sortedArray.length) {
                var memberName = sortedArray[membersCount].keys[level];
                subArray = $.grep(sortedArray, function (item) { return item.keys[level] == memberName; });
                if (subArray.length > 1 && level + 1 < sortedArray[membersCount].keys.length)
                    subArray = this._sortHeaders(subArray, axisElements, level + 1);
                resultantArray = resultantArray.concat(subArray);
                membersCount += subArray.length;
            }
            return resultantArray;
        },

        _getReflectedValue: function (recSet, fieldName) {
            var val = $(recSet).prop(fieldName);
            return val;
        },

        _isMemberExist: function (axis, axisData, value) {
            switch (axis) {
                case "row":
                    var pos, flag = false;
                    if (rowKeysCalcValues.length == 0)
                        rowKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < rowKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == rowKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++)
                            if (rowKeysCalcValues[pos].value == null) {
                                rowKeysCalcValues[pos].value = value;
                                break;
                            }
                            else
                                rowKeysCalcValues[pos].value.keys[vC] += value.keys[vC];
                    }
                    else
                        rowKeysCalcValues.push(axisData);

                    break;
                case "column":
                    var pos, flag = false;
                    if (colKeysCalcValues.length == 0)
                        colKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < colKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == colKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++)
                            if (colKeysCalcValues[pos].value == null) {
                                colKeysCalcValues[pos].value = value;
                                break;
                            }
                            else
                                colKeysCalcValues[pos].value.keys[vC] += value.keys[vC];
                    }
                    else
                        colKeysCalcValues.push(axisData);
                    break;
                case "calc":
                    var pos, flag = false;
                    if (tableKeysCalcValues.length == 0)
                        tableKeysCalcValues.push(axisData);
                    for (var cnt = 0; cnt < tableKeysCalcValues.length; cnt++)
                        if (axisData.uniqueName == tableKeysCalcValues[cnt].uniqueName) {
                            flag = true; pos = cnt;
                            break;
                        }
                    if (flag) {
                        for (var vC = 0; vC < value.keys.length; vC++) {
                            if (tableKeysCalcValues[pos].value == null) {
                                tableKeysCalcValues[pos].value = value;
                                tableKeysCalcValues[pos].value["count"] = 1;
                                for (var i = 0; i < value.keys.length; i++) {
                                    if (summaryTypes[i] == ej.PivotAnalysis.SummaryType.Count)
                                        tableKeysCalcValues[pos].value.keys[i] = tableKeysCalcValues[pos].value.count;
                                }
                                break;
                            }
                            else {
                                tableKeysCalcValues[pos].value.count++;
                                tableKeysCalcValues[pos].value.keys[vC] = this._getSummaryValue(tableKeysCalcValues[pos].value.keys[vC], value.keys[vC], tableKeysCalcValues[pos].value.count, summaryTypes[vC]);
                            }
                        }
                    }
                    else {
                        tableKeysCalcValues.push(axisData);
                        tableKeysCalcValues[tableKeysCalcValues.length - 1].value = value;
                        for (var i = 0; i < value.keys.length; i++) {
                            if (summaryTypes[i] == ej.PivotAnalysis.SummaryType.Count)
                                tableKeysCalcValues[tableKeysCalcValues.length - 1].value.keys[i] = 1;
                            tableKeysCalcValues[tableKeysCalcValues.length - 1].value["count"] = 1;
                        }
                    }
                    break;
            }
        },

        _getSummaryValue: function (oldValue, newValue, count, type) {
            switch (type) {
                case ej.PivotAnalysis.SummaryType.Sum:
                    oldValue += newValue;
                    break;
                case ej.PivotAnalysis.SummaryType.Average:
                    oldValue = (oldValue * (count - 1) + newValue) / count;
                    if (Math.floor(oldValue) != oldValue) oldValue = Number(oldValue.toFixed(2));
                    break;
                case ej.PivotAnalysis.SummaryType.Min:
                    oldValue = count == 1 ? newValue : Math.min(oldValue, newValue);
                    break;
                case ej.PivotAnalysis.SummaryType.Max:
                    oldValue = count == 1 ? newValue : Math.max(oldValue, newValue);
                    break;
                case ej.PivotAnalysis.SummaryType.Count:
                    oldValue = count;
                    break;
            }
            return oldValue;
        },

        _insertTotalHeader: function (axisLen, axisItems, headerList) {
            if (axisItems.length <= 1) {
                headerList.push({ cellType: "RGTot", keys: ["Grand Total"], tot: "sub" });
                return;
            }
            var level = -1;
            for (var lC = axisItems.length - axisLen; lC >= 0; lC--) {
                level++;
                var pivotCount = headerList.length;
                if (pivotCount > 0) {
                    var prevVal = headerList[0].uniqueName.split('.'), prevTxt = headerList[0].keys[level];
                    prevVal = prevVal.slice(0, lC + 1).join('.');
                    var newVal = "", prevCnt = 0, newTxt = "";
                    for (var hCnt = 1; hCnt <= pivotCount; hCnt++) {
                        if (headerList[hCnt] != undefined) {

                            newVal = headerList[hCnt].uniqueName.split('.');
                            newVal = newVal.slice(0, lC + 1).join('.');
                            newTxt = headerList[hCnt].keys[lC + 1];
                        }
                        else {
                            newVal = undefined;
                        }
                        if (newVal != undefined && newVal.indexOf("Total") == -1) {
                            if (prevVal != undefined && ((newVal != prevVal))) {
                                headerList.splice(hCnt, 0, { keys: [prevVal.split('.')[lC] + " Total"], cellType: "SubTot", uniqueName: prevVal, level: lC });
                                if (headerList[prevCnt]['span'] == undefined)

                                    headerList[prevCnt]['span'] = [];
                                headerList[prevCnt]['span'][lC] = hCnt - prevCnt;

                                hCnt++; pivotCount++; prevVal = newVal; prevCnt = hCnt; prevTxt = newTxt;
                            }

                        }
                        else if (prevVal != undefined) {
                            headerList.splice(hCnt, 0, { keys: [prevVal.split('.')[lC] + " Total"], cellType: "SubTot:", uniqueName: prevVal, level: lC });
                            if (headerList[prevCnt]['span'] == undefined)

                                headerList[prevCnt]['span'] = [];
                            headerList[prevCnt]['span'][lC] = hCnt - prevCnt;
                            hCnt++; pivotCount++; prevVal = newVal; prevCnt = hCnt; prevTxt = newTxt;
                        }
                    }
                }
            }
            headerList.push({ cellType: "RGTot", keys: ["Grand Total"] });
        },

        _isPreviousLevelEqual: function (headerList, hCnt, prevCnt, level) {
            for (var prev = level - 1; prev >= 0; prev--) {
                if (headerList[hCnt].keys[prev] != headerList[prevCnt].keys[prev])
                    return true;
                else
                    return false;
            }
        },

        _calculateValues: function (dataSource) {
            var rowCount = rowKeysCalcValues.length + 1;
            var colCount = colKeysCalcValues.length == 0 ? 0 : (colKeysCalcValues.length * dataSource.values.length) + 1;
            gridMatrix = new Array(rowCount + dataSource.rows.length + 1);
            this._populateRowHeaders(dataSource, rowCount + dataSource.rows.length + 1, (dataSource.rows.length == 0 ? 1 : dataSource.rows.length));
            var colHdRowCnt = dataSource.columns.length + 1, colHdColCnt = colCount + (dataSource.rows.length == 0 ? 1 : dataSource.rows.length);
            this._populateColumnHeaders(dataSource, colHdRowCnt, colHdColCnt);
            this._populateCalcTable(dataSource);
            tRowCnt = rowCount + colHdRowCnt, tColCnt = colHdColCnt;
        },

        _populateRowHeaders: function (dataSource, rowCnt, colCnt) {
            if (rowKeysCalcValues.length == 0)
                return;
            var rowIndex = dataSource.columns.length + 1;
            gridMatrix = [];
            var lastCol = dataSource.rows.length, prevVal = "";
            for (var cnt = 0; cnt < rowKeysCalcValues.length; cnt++) {
                prevVal = rowKeysCalcValues[cnt];
                {
                    var colIndex = 0, tempCIndx = 0, tempCSpan = 0, rowKLen = 0;
                    if (rowKeysCalcValues[cnt].keys != undefined && rowKeysCalcValues[cnt].keys.length != 0) {
                        gridMatrix[rowIndex] = new Array(colCnt);
                        rowKLen = rowKeysCalcValues[cnt].keys.length;
                        for (kCnt = 0; kCnt < rowKLen; kCnt++) {
                            if (rowKeysCalcValues[cnt].cellType != undefined) {
                                if (rowKeysCalcValues[cnt].cellType.indexOf("SubTot") > -1) {
                                    tempCIndx = rowKeysCalcValues[cnt].level + colIndex;
                                    tempCSpan = colCnt - rowKeysCalcValues[cnt].level;
                                    cellType = "summary";
                                }
                                else {
                                    cellType = "summary";
                                    tempCIndx = colIndex; tempCSpan = dataSource.rows.length;
                                }
                            }
                            else {
                                cellType = "rowheader";
                                tempCIndx = colIndex;
                                tempCSpan = 1;
                            }
                            var expand = rowKLen > 1 ? rowKLen - kCnt > 1 ? 1 : 0 : 0;
                            gridMatrix[rowIndex][tempCIndx] = {
                                Index: tempCIndx + ',' + rowIndex, CSS: cellType, Value: rowKeysCalcValues[cnt].keys[kCnt], State: expand,
                                RowSpan: (rowKeysCalcValues[cnt].span != undefined ? rowKeysCalcValues[cnt].span[kCnt] : 1),
                                ColSpan: tempCSpan, Info: "", Span: "None", Expander: expand
                            };
                            colIndex++;
                        }
                    }
                    rowIndex++;
                }
            }
            cellType = "";
        },

        _populateColumnHeaders: function (dataSource, colHdRowCnt, colHdColCnt) {
            if (colKeysCalcValues.length == 0)
                return;
            var colIndex = tempCnt = (dataSource.rows.length == 0 ? 1 : dataSource.rows.length), loopCnt = dataSource.values.length, lastRow = dataSource.columns.length, prevVal = "", rowIndex = colKLen = 0;
            for (var cnt = 0; cnt < colKeysCalcValues.length; cnt++) {
                rowIndex = 0, tempRIndx = 0, tempRSpan = 0, tempCSpan = 0;
                prevVal = colKeysCalcValues[cnt].keys;
                if (gridMatrix[rowIndex] == undefined)
                    gridMatrix[rowIndex] = new Array();
                colKLen = colKeysCalcValues[cnt].keys.length;
                for (kCnt = 0; kCnt < colKLen; kCnt++) {
                    if (gridMatrix[rowIndex] == undefined)
                        gridMatrix[rowIndex] = new Array();

                    if (colKeysCalcValues[cnt].cellType != undefined) {
                        if (colKeysCalcValues[cnt].cellType.indexOf("SubTot") > -1) {
                            tempRIndx = colKeysCalcValues[cnt].level + rowIndex;
                            tempRSpan = colHdRowCnt - colKeysCalcValues[cnt].level - 1;
                            cellType = "summary";
                        }
                        else {
                            tempRIndx = rowIndex; tempRSpan = dataSource.columns.length;
                            cellType = "summary";
                        }
                    }
                    else {
                        tempRIndx = rowIndex;
                        tempRSpan = 1;
                        cellType = "colheader";
                    }
                    var expand = colKLen > 1 ? colKLen - kCnt > 1 ? 1 : 0 : 0;
                    for (var cCnt = 0; cCnt < loopCnt; cCnt++) {
                        gridMatrix[tempRIndx][(loopCnt * cnt) + cCnt + tempCnt] = {
                            Index: colIndex + ',' + tempRIndx, CSS: cellType, Value: colKeysCalcValues[cnt].keys[kCnt], State: expand,
                            ColSpan: (colKeysCalcValues[cnt].span != undefined ? colKeysCalcValues[cnt].span[kCnt] : 1) * loopCnt,
                            RowSpan: tempRSpan, Info: "", Span: "None", Expander: expand
                        };
                    }

                    rowIndex++;

                }
                for (var cCnt = 0; cCnt < loopCnt; cCnt++) {
                    if (gridMatrix[rowIndex] == undefined)
                        gridMatrix[rowIndex] = new Array();

                    gridMatrix[lastRow][(loopCnt * cnt) + cCnt + tempCnt] = {
                        Index: ((loopCnt * cnt) + cCnt + tempCnt) + ',' + rowIndex, CSS: cellType + " calc", Value: dataSource.values[cCnt].fieldName, State: 0,
                        ColSpan: 1,
                        RowSpan: 1, Info: "", Span: "None", Expander: 0
                    };
                }
                colIndex++;
            }
            cellType = "";
        },

        _populateCalcTable: function (dataSource) {
            var calValue = [], calCnt = dataSource.values.length;
            var colIndex = (dataSource.rows.length == 0 ? 1 : dataSource.rows.length), rowIndex = dataSource.columns.length + 1, sTot = 0, isUniqe = false, totRIndx = 0;
            var rwIndx = rowIndex, clIndx, totFlagR = false, totCIndx = 0, totFlagC = false;

            for (var rCnt = 0; rCnt < rowKeysCalcValues.length; rCnt++) {
                colTotCalc = []; clIndx = colIndex;
                isUniqe = true;
                if (gridMatrix[rCnt + rowIndex] == undefined)
                    gridMatrix[rCnt + rowIndex] = new Array();
                rowTotCalc[totRIndx] = new Array();

                for (cCnt = 0; cCnt < colKeysCalcValues.length; cCnt++) {
                    calValue = [];
                    cellType = "value";
                    if (dataSource.columns.length > 0 && dataSource.rows.length > 0)
                        $.grep(tableKeysCalcValues, function (item) {
                            if (item.uniqueName == rowKeysCalcValues[rCnt].uniqueName + "." + colKeysCalcValues[cCnt].uniqueName)
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                            return;
                        });
                    else if (dataSource.rows.length == 0)
                        $.grep(tableKeysCalcValues, function (item) {
                            if (item.uniqueName == colKeysCalcValues[cCnt].uniqueName)
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                            return;
                        });
                    else
                        $.grep(tableKeysCalcValues, function (item) {
                            if (item.uniqueName == rowKeysCalcValues[rCnt].uniqueName)
                                for (ky = 0 ; ky < item.value.keys.length; ky++)
                                    calValue.push(item.value.keys[ky]);
                            return;
                        });
                    if (colKeysCalcValues[cCnt].cellType != undefined && (colKeysCalcValues[cCnt].cellType.indexOf("SubTot") > -1 || colKeysCalcValues[cCnt].cellType.indexOf("RGTot") > -1)) {
                        calValue = [];
                        for (var ky = 0; ky < calCnt; ky++) {
                            var count = 0, cCount = 0;
                            for (var tCnt = clIndx ; tCnt <= ((cCnt * calCnt) + colIndex) ; tCnt++) {
                                if (gridMatrix[rCnt + rowIndex] != undefined && gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky] != undefined && gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky].Value != undefined) {
                                    if (calValue[ky] == undefined)
                                        calValue[ky] = 0;
                                    cCount++;
                                    calValue[ky] = this._getSummaryValue(calValue[ky], gridMatrix[rCnt + rowIndex][clIndx + (count * calCnt) + ky].Value, cCount, summaryTypes[ky] == "count" ? "sum" : summaryTypes[ky]);
                                }
                                count++;
                            }

                        }
                        sTot = 0;
                        clIndx = ((cCnt + 1) * calCnt) + colIndex;
                        if (calValue != 0) {
                            colTotCalc.push({ uniqueName: colKeysCalcValues[cCnt].uniqueName, level: colKeysCalcValues[cCnt].level, value: calValue });
                        }
                        if (colKeysCalcValues[cCnt - 1].cellType != undefined && colKeysCalcValues[cCnt - 1].cellType.indexOf("SubTot") > -1 && colKeysCalcValues[cCnt - 1].cellType.indexOf("RGTot") == -1) {
                            var tempVal = $.Enumerable.From(colTotCalc).Where(function (x) {
                                return x != undefined && x.uniqueName != undefined && colKeysCalcValues[cCnt].uniqueName != undefined && x.level != undefined && colKeysCalcValues[cCnt].level != undefined && x.uniqueName.indexOf(colKeysCalcValues[cCnt].uniqueName) === 0 && colKeysCalcValues[cCnt].level + 1 == x.level;

                            }).Select(function (val) {
                                for (var ky = 0; ky < val.value.length; ky++) {
                                    if (calValue[ky] == undefined)
                                        calValue[ky] = 0;
                                    calValue[ky] += val.value[ky];
                                }
                                return calValue;
                            }).ToArray();

                            if (calValue != 0) {
                                colTotCalc.push({ uniqueName: colKeysCalcValues[cCnt].uniqueName, level: colKeysCalcValues[cCnt].level, value: calValue });

                            }
                        }
                        cellType = "summary value";
                    }
                    if (colKeysCalcValues[cCnt].cellType != undefined && colKeysCalcValues[cCnt].cellType.indexOf("RGTot") > -1 && calValue == 0) {
                        calValue = [];
                        var tempVal = $.Enumerable.From(colTotCalc).Where(function (x) {
                            return x != undefined && x != undefined && x.level != undefined && x.level == 0;
                        }).Select(function (val) {

                            for (var ky = 0; ky < val.value.length; ky++) {
                                if (calValue[ky] == undefined)
                                    calValue[ky] = 0;
                                calValue[ky] += val.value[ky];
                            }
                            return calValue;
                        }).ToArray();
                        cellType = "summary value";
                    }
                    if (rowKeysCalcValues[rCnt].cellType != undefined && (rowKeysCalcValues[rCnt].cellType.indexOf("SubTot") > -1 || rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") > -1)) {
                        calValue = [];
                        var memberName = rowKeysCalcValues[rCnt].uniqueName;
                        if (rowKeysCalcValues[rCnt - 1].cellType != undefined && rowKeysCalcValues[rCnt - 1].cellType.indexOf("SubTot") > -1 && rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") == -1) {
                            var tempVal = $.Enumerable.From(rowTotCalc).Where(function (x) {
                                return x[0] != undefined && x[0].uniqueName != undefined && rowKeysCalcValues[rCnt].uniqueName != undefined && x[0].level != undefined && rowKeysCalcValues[rCnt].level != undefined && x[0].uniqueName.indexOf(rowKeysCalcValues[rCnt].uniqueName) === 0 && rowKeysCalcValues[rCnt].level + 1 == x[0].level;
                            }).Select(function (val) {
                                if (val[colIndex + cCnt].length > 0)
                                    for (var ky = 0; ky < val[colIndex + cCnt].length; ky++) {
                                        if (calValue[ky] == undefined)
                                            calValue[ky] = 0;
                                        calValue[ky] += val[colIndex + cCnt][ky];
                                    }
                                return calValue;
                            }).ToArray();
                        }
                        if (rowKeysCalcValues[rCnt].cellType != undefined && rowKeysCalcValues[rCnt].cellType.indexOf("RGTot") > -1) {
                            var cCount = 0;
                            var tempVal = $.Enumerable.From(rowTotCalc).Where(function (x) {
                                return x != undefined && x[0] != undefined && x[0].level != undefined && x[0].level == 0;
                            }).Select(function (val) {
                                if (val[colIndex + cCnt].length > 0) {
                                    cCount++;
                                    for (var ky = 0; ky < val[colIndex + cCnt].length; ky++) {
                                        if (calValue[ky] == undefined)
                                            calValue[ky] = 0;
                                        calValue[ky] = ej.PivotAnalysis._getSummaryValue(calValue[ky], val[colIndex + cCnt][ky], cCount, summaryTypes[ky] == "count" ? "sum" : summaryTypes[ky]);
                                    }
                                }
                                return calValue;
                            }).ToArray();
                        }
                        var cCount = 1;
                        for (var tCnt = rwIndx ; tCnt <= (rCnt + rowIndex) ; tCnt++) {
                            var isAvailable = false;
                            for (var ky = 0; ky < calCnt; ky++) {
                                var count = 0;
                                if (gridMatrix[tCnt] != undefined && gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky] != undefined && gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky].Value != undefined) {
                                    if (calValue[ky] == undefined)
                                        calValue[ky] = 0;
                                    isAvailable = true;
                                    calValue[ky] = this._getSummaryValue(calValue[ky], gridMatrix[tCnt][colIndex + (cCnt * calCnt) + ky].Value, cCount, summaryTypes[ky] == "count" ? "sum" : summaryTypes[ky]);
                                }
                                count++;
                            }
                            if (isAvailable) cCount++;
                        }

                        sTot = 0;
                        totFlagR = true;
                        if (isUniqe) {
                            rowTotCalc[totRIndx][0] = { uniqueName: rowKeysCalcValues[rCnt].uniqueName, level: rowKeysCalcValues[rCnt].level };
                            isUniqe = false;
                        }
                        rowTotCalc[totRIndx][colIndex + cCnt] = calValue;

                        cellType = "summary value";
                    }

                    for (var val = 0; val < calCnt; val++) {
                        if (calValue != undefined && calValue.length != undefined) {
                            gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex] = {
                                Index: ((calCnt * cCnt) + val + colIndex) + ',' + rowIndex + rCnt, CSS: cellType, Value: calValue[val], State: 0,
                                ColSpan: 1,
                                RowSpan: 1, Info: "", Span: "None", Expander: 0
                            };
                        }
                        else
                            gridMatrix[rowIndex + rCnt][(calCnt * cCnt) + val + colIndex] = 0;
                    }
                }
                if (totFlagR) {
                    totRIndx++;
                    rwIndx = rCnt + rowIndex + 1; totFlagR = false;
                }
            }
            return gridMatrix;
        }
    }

    ej.PivotAnalysis.SortOrder = {
        Ascending: "ascending",
        Descending: "descending",
    };

    ej.PivotAnalysis.FilterType = {
        Exclude: "exclude",
        Include: "include"
    };

    ej.PivotAnalysis.SummaryType = {
        Sum: "sum",
        Average: "average",
        Count: "count",
        Min: "min",
        Max: "max"
    };

})(jQuery, Syncfusion);